
//	base code for simple applications
//  Copyright (c) 2002 Takeo Igarashi 

import java.awt.event.*;
import java.awt.*;
import java.util.*;


class MainPanel extends Panel implements MyMenuBarInterface
{

	//
	// initialize
	//
	MainPanel(){
		MouseDispatcher mouseDispatcher = new MouseDispatcher();
		addMouseListener(mouseDispatcher);
		addMouseMotionListener(mouseDispatcher);
		
		sheet = new Sheet(this);
	}
	
	Sheet sheet;
	
	
	

	
	
	
	//
	// set menuBar
	//
	public void setMenuItems(MyMenuBar menuBar){
		Menu fileMenu = new java.awt.Menu("File");
		menuBar.add(fileMenu);

		fileMenu.add(new MyMenuItem("random", menuBar));
		fileMenu.add(new MyMenuItem("load", menuBar));
		fileMenu.add(new MyMenuItem("save", menuBar));
		fileMenu.add(new MyMenuItem("quit", menuBar));
	}
	public void menuItemSelected(String name){
		if (name.equals("random"))
			random();
		else if (name.equals("load"))
			load();
		else if (name.equals("save"))
			save();
		else if (name.equals("quit"))
			System.exit(0);
	}
	
	
	
	
	
	
	public void random(){
		sheet.set_random();
		repaint();
	}
	public void load(){
		LoadDialog dialog = new LoadDialog(Main.frame);
		dialog.setVisible(true);
		if (!dialog.filename.equals("cancel")){
			sheet.load(dialog.filename);
		}
		repaint();
		/*
		java.awt.FileDialog fileDialog = new java.awt.FileDialog( Main.frame, "Load", java.awt.FileDialog.LOAD );
		fileDialog.setDirectory(".\\");
		fileDialog.setFile("*.txt");
		fileDialog.setVisible(true);
		if( fileDialog.getFile()!=null )
		{
			String filename = fileDialog.getDirectory() + fileDialog.getFile();
			sheet.load(filename);
		}
		fileDialog.dispose();

		repaint();
		*/
	}	
	public void save(){
		java.awt.FileDialog fileDialog = new java.awt.FileDialog( Main.frame, "Save", java.awt.FileDialog.LOAD );
		fileDialog.setDirectory(".\\");
		fileDialog.setFile("*.txt");
		fileDialog.setVisible(true);
		if( fileDialog.getFile()!=null )
		{
			String filename = fileDialog.getFile();
			sheet.save(filename);
		}
		fileDialog.dispose();

		repaint();
	}	
		
	
	
	
	
	
	
	
	

	
	//
	// paint screen
	//
	Image buffered_image = null;
	public void update(Graphics g) {
		paint(g);
	}
	public void paint(Graphics g) {

		//double buffering
		if (buffered_image == null || buffered_image.getWidth(null) != getSize().width
								   || buffered_image.getHeight(null) != getSize().height)
			buffered_image = createImage(getSize().width, getSize().height);
		Graphics bg = buffered_image.getGraphics();

		// clear
		bg.setColor(Color.white);
		bg.fillRect(0,0, getSize().width, getSize().height);

		
		// main
		sheet.paint(bg);

		if (pickInfo != null)
			pickInfo.paint(bg);
		if (dropInfo != null)
			dropInfo.paint(bg);
	
	
						  
		//double buffering
		bg.dispose();
      
		g.drawImage(buffered_image,0,0,this);

	}
	

	
	
	
	
	
	
   
	//   
	// central event dispatcher
	//
	
	PickInfo pickInfo;
	PickInfo dropInfo;

	public class MouseDispatcher 
		extends MouseAdapter implements MouseMotionListener{

  		public void mouseMoved(MouseEvent e) {
  		}
  		public void mousePressed(MouseEvent e) {
			Point p = e.getPoint();
			
			pickInfo = sheet.pick(p);
			
			repaint();
		}
  		public void mouseDragged(MouseEvent e) {
			Point p = e.getPoint();

			dropInfo = sheet.pick(p);
			
			repaint();
		}	
		public void mouseReleased(MouseEvent e) {
			Point p = e.getPoint();
			
			dropInfo = sheet.pick(p);
			
			if (pickInfo != null && dropInfo != null){
				sheet.drop(pickInfo, dropInfo);
			}
			
			pickInfo = null;
			dropInfo = null;
			
			repaint();
		}
		
		public void mouseClicked(MouseEvent e){	
		}
    }
}