import java.awt.*;
import java.util.*;
import java.awt.event.*;


// reusable menubar class

public class MyMenuBar extends MenuBar implements ActionListener
{
	MyMenuBar myMenuBar;
	MyMenuBarInterface target;
	MyMenuBar(MyMenuBarInterface target){
		super();
		myMenuBar = this;
		this.target = target;

		target.setMenuItems(this);
		
	}

	public void actionPerformed(java.awt.event.ActionEvent event)
	{
		if (event.getSource() instanceof MyMenuItem){
			String label = ((MyMenuItem)event.getSource()).getLabel();
			
			target.menuItemSelected(label);
		}

	}


}

class MyMenuItem extends MenuItem {
	MyMenuItem(String label, MyMenuBar menuBar){
		super();
		setLabel(label);
		addActionListener(menuBar);
	}
}

interface MyMenuBarInterface {
	public void menuItemSelected(String name);
	public void setMenuItems(MyMenuBar menuBar);
}
