import java.util.*;
import java.awt.*;
import java.io.*;
import java.net.*;

public class Sheet
{
	Panel panel;
	Color[] color = {new Color(255,192,192), new Color(192,255,192), new Color(192,192,255)};

	Vector persons = new Vector();
	Vector labs = new Vector();

	
	Sheet(Panel panel){
		this.panel = panel;
		load("requested1.txt");
	}
	
	

	
		
	
	
	
	
	public void paint(Graphics g){
		pickInfos = new Vector();
		
		paint_persons(g);
		//paint_labs(g);
	}
	
	
	int X0 = 10;
	int Y0 = 20;
	int W_PERSON = 70;
	int W_LAB = 50;
	int H0 = 18;
	
	public void paint_persons(Graphics g){
		g.setColor(Color.black);

		g.drawString("1st", X0+W_PERSON +W_LAB*0 +12 , Y0 - 3 );
		g.drawString("2nd", X0+W_PERSON +W_LAB*1 +12 , Y0 - 3 );
		g.drawString("3rd", X0+W_PERSON +W_LAB*2 +12 , Y0 - 3 );
		g.drawString("4th", X0+W_PERSON +W_LAB*3 +12 , Y0 - 3 );
		g.drawString("5th", X0+W_PERSON +W_LAB*4 +12 , Y0 - 3 );

		
		for(int i=0; i<persons.size(); i++){
			Person person = (Person) persons.elementAt(i);
			g.drawString(person.name, X0 +2, Y0 + H0 * i +15);
			g.drawRect(X0,    Y0 + H0 * i, W_PERSON, H0);
		
			for(int j=0; j<5; j++){
				if (person.requested[j] == null)
					continue;
				
				Rectangle bbox = new Rectangle(X0+W_PERSON + W_LAB*j + 5, Y0 + H0 * i, W_LAB, H0);
				
				int k = person.get_assigned_term(person.requested[j]);
				if (k != -1){
					g.setColor(color[k]);
					g.fillRect(bbox.x, bbox.y, bbox.width, bbox.height);
				}
				
				g.setColor(Color.black);
				g.drawString(person.requested[j].name, bbox.x +2, bbox.y +15);
				g.drawRect(bbox.x, bbox.y, bbox.width, bbox.height);
				pickInfos.addElement(new PickInfo(PickInfo.PERSON_REQUESTED, person, j, bbox));
			}
		}
	}


	
	
	
	

	
	

	
	
	
	
	
	
	Vector pickInfos;
	
	//
	// find a cell under the cursor
	//
	public PickInfo pick(Point p){
		for(int i=0; i<pickInfos.size(); i++){
			PickInfo pickInfo = (PickInfo) pickInfos.elementAt(i);
			if (pickInfo.bbox.contains(p))
				return pickInfo;
		}
		return null;
	}
	
	
	
	public void drop(PickInfo picked, PickInfo dropped){
		if (picked.person != dropped.person || picked.lab == dropped.lab)
			return;
		
		Person person = picked.person;
		
		int n = person.get_assigned_term(picked.lab);
		int m = person.get_assigned_term(dropped.lab);
		
		if (n!=-1)
			person.assigned[n] = dropped.lab;
		if (m!=-1)
			person.assigned[m] = picked.lab;
		
		panel.repaint();
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	// set random values to "requests"
	public void set_random(){
		for(int i=0; i<persons.size(); i++){
			Person person = (Person) persons.elementAt(i);	
			for(int j=0; j<5; j++)
				person.requested[j] = get_random(person, j);
			for(int j=0; j<3; j++)
				person.assigned[j] = person.requested[j];
		}
	}
	public Lab get_random(Person person, int j){
		int index = (int)(labs.size() * Math.random());
		Lab lab = (Lab) labs.elementAt(index);
		for(int i=0; i<j; i++)
			if (person.requested[i] == lab)
				return get_random(person, j);
		return lab;
	}
				

	
	
	
	
	
	
	
	
	// load requests
	public void load(String filename){
		try{
		BufferedReader in;
		if (Main.applet != null){
			InputStream is = new URL(Main.applet.getDocumentBase(), 
					filename).openStream();
			in   = new BufferedReader(new InputStreamReader(is, "SJIS")); 
		} 
		else{
			FileInputStream is = new FileInputStream ( filename );
			in   = new BufferedReader(new InputStreamReader(is, "SJIS")); 
		}
		
		persons = new Vector();
		
		while(true){
			String line = in.readLine();
			if (line == null) break;
	  
			StringTokenizer st = new StringTokenizer(line);
			String name = st.nextToken();	
			Person person = new Person(name);
			for(int i=0; st. hasMoreTokens(); i++){
				person.requested[i] = get_lab(st.nextToken());
			}
			persons.addElement(person);
		}
		
		for(int i=0; i<persons.size(); i++){
			Person person = (Person) persons.elementAt(i);
			for(int j=0; j<3; j++)
				person.assigned[j] = person.requested[j];
		}
		
		}catch(Exception e){
			System.out.println(""+e);
		}
		
	}
	
	public Lab get_lab(String name){
		for(int i=0; i<labs.size(); i++){
			Lab lab = (Lab) labs.elementAt(i);
			if (lab.name.equals(name))
				return lab;
		}
		Lab lab = new Lab(name);
		labs.addElement(lab);
		return lab;
	}
	
	
	
	
	// save requests
	public void save(String filename){
		try{
			
		BufferedWriter out   = new BufferedWriter(
			new FileWriter(filename)); 

		for(int i=0; i<persons.size(); i++){
			Person person = (Person) persons.elementAt(i);
			out.write(person.name+"\t");
			for(int j=0; j<5; j++)
				if (person.requested[j] != null)
					out.write(person.requested[j].name+"\t");
			out.newLine();
		}
		out.flush();
		out.close();
		
		}catch(Exception e){
			System.out.println(""+e);
		}
	}		
	
	
	
	
	
}










// basic data structure

	class Person {
		String name;
		Lab[] requested = new Lab[5];
		Lab[] assigned = new Lab[3];
		
		Person(String _name){
			name = _name;
		}
		int get_assigned_term(Lab lab){
			for(int i=0; i<3; i++)
				if (assigned[i] == lab)
					return i;
			return -1;
		}
	}
	class Lab {
		String name;
		Vector[] requested = new Vector[5];
		Vector[] assigned = new Vector[3];
		Lab(String _name){
			name = _name;
		}

	}